(function() {
  var __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  PuppetEnterpriseConsole.NodeEncoder = (function() {

    function NodeEncoder() {}

    NodeEncoder.prototype.encode = function(nodes) {
      return JSON.stringify(nodes.map(function(n) {
        return n.get('name');
      }));
    };

    NodeEncoder.prototype.decode = function(nodes) {
      if (PuppetEnterpriseConsole.Node.get('batmanState') !== 'loaded') {
        return nodes;
      }
      return PuppetEnterpriseConsole.Node.get('all').toArray().filter(function(e) {
        return nodes.some(function(node) {
          return node === e.get('name');
        });
      });
    };

    return NodeEncoder;

  })();

  PuppetEnterpriseConsole.Agent = (function(_super) {
    var _this = this;

    __extends(Agent, _super);

    function Agent() {
      return Agent.__super__.constructor.apply(this, arguments);
    }

    Agent.resourceName = 'agent';

    Agent.encode('name', 'description', 'version');

    Agent.encode('nodes', new PuppetEnterpriseConsole.NodeEncoder());

    Agent.primaryKey = 'name';

    Agent.encode('actions', {
      encode: function(list) {
        return list.toArray();
      },
      decode: function(list) {
        var action, _i, _len;
        for (_i = 0, _len = list.length; _i < _len; _i++) {
          action = list[_i];
          action.has_options = Object.keys(action.input).length > 0;
        }
        return (function(func, args, ctor) {
          ctor.prototype = func.prototype;
          var child = new ctor, result = func.apply(child, args), t = typeof result;
          return t == "object" || t == "function" ? result || child : child;
        })(Batman.Set, list, function(){});
      }
    });

    Agent.persist(Batman.RestStorage);

    Agent.url = '/live-management/lm/mc_agents';

    Agent.prototype.url = function() {
      return "/live-management/lm/mc_agents";
    };

    PuppetEnterpriseConsole.on('ready', function() {
      return PuppetEnterpriseConsole.Node.observe('nodeSetID', function() {
        var agent, nodes, _i, _len, _ref, _results;
        _ref = Agent.get('agents').toArray();
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          agent = _ref[_i];
          if (agent.get('nodes').length && !(agent.get('nodes')[0].constructor.get != null)) {
            nodes = PuppetEnterpriseConsole.Node.get('all').toArray().filter(function(e) {
              return agent.get('nodes').some(function(node) {
                return node === e.get('name');
              });
            });
            agent.set('nodes', nodes);
            _results.push(Agent.agent(agent.get('name')).set('nodes', nodes));
          } else {
            _results.push(void 0);
          }
        }
        return _results;
      });
    });

    Agent.set('loadedAgents', new Batman.Set());

    Agent.classAccessor('agents', {
      get: function() {
        var loaded;
        loaded = this.get('loadedAgents');
        if (!loaded.get('state')) {
          loaded.set('state', 'loading');
          this.load(function(err, agents) {
            var agent, id, _i, _len;
            agents = agents.filter(function(e) {
              return e.get('actions').length > 0;
            });
            for (_i = 0, _len = agents.length; _i < _len; _i++) {
              agent = agents[_i];
              id = agent.get('name');
              if (Agent[id] == null) {
                Agent[id] = new Batman.Object();
              }
              Agent[id].set('data', agent);
            }
            loaded.add.apply(loaded, agents);
            return loaded.set('state', 'loaded');
          });
        }
        return loaded;
      }
    });

    Agent.agent = function(id) {
      if (Agent[id] == null) {
        Agent[id] = new Batman.Object();
      }
      return Agent[id];
    };

    Agent.prototype.run = function(action_name, nodeset_id, params) {
      var results,
        _this = this;
      results = new Batman.Object();
      $.ajax('/live-management/lm/mc_run', {
        async: true,
        type: 'POST',
        data: {
          agent_name: this.get('name'),
          action_name: action_name,
          nodeset_id: nodeset_id,
          input: params
        },
        success: function(data) {
          var i, nodes, result, summary_nodes, _i, _len;
          for (_i = 0, _len = data.length; _i < _len; _i++) {
            result = data[_i];
            nodes = result[1];
            summary_nodes = [];
            i = 0;
            while (i < 3 && i < nodes.length) {
              summary_nodes.push(nodes[i++]);
            }
            result.push(summary_nodes);
            result.push(nodes.length - summary_nodes.length);
          }
          return results.set('data', data);
        }
      });
      return results;
    };

    return Agent;

  }).call(this, Batman.Model);

}).call(this);
